*
      SUBROUTINE PAZ_HEEV1(NAME, N, NPROCS, MMIN, NB, NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)  
*          
*     PZHEEV1, PZHEEV3, PZHEEV5
*
*  
      INTEGER            N, NPROCS, MMIN, NB, NPROW, NPCOL
      CHARACTER*(*)   NAME, TRANS
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6, TRANS='N')
*
*  
      INTEGER            CTXT, I, IAM, INFO, IPA,
     $                   IPW, IPWOR, IPIWOR, IPRWOR,
     $                   NP, NQ, M, MXLLDA,
     $                   MYCOL, MYROW, MXNP, MXNQ, NN,
     $                   LRWORK, LWORK, LIWORK, IA, JA,
     $                   WORKSIZ, NP0, NB0
*
*  
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*
*  
      INTRINSIC          DBLE, MAX, SQRT, INT, REAL
*
*  
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
*
      NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
      IF( NB0.LT.4 ) NB = 2
*1      NB0 = INT(REAL( N/NPROW) )
*1      IF( NB0.LT.4 ) NB = NB0
      IF( NB0.GE.4 .AND. NB0.LT.8 ) NB = 4
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 ) NB = 32
*
*        
*
      MXNP = NUMROC( N, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXNP
*
*     A
      IPA = 1
*
*         ,
* ..  / CAZ_HEEV1     
* (- IPEV)
*     WORK
      IPWOR = IPA + MXLLDA*MXNQ
*
      IF( NAME .NE. 'PZHEEV1' ) GOTO 2
*
*   ,    PZHEEV1
*
      LWORK = 5*N + MAX( NB*( MXNP + 1 ), 3*NB ) + 1
      LRWORK = 2*N
      IPRWOR = IPWOR + LWORK
      IPW = IPRWOR + LRWORK
*
      GOTO 3
*
    2 IF( NAME .NE. 'PZHEEV3' .AND. NAME .NE. 'PZHEEV5' ) GOTO 10
*
*   ,     PZHEEV3(5)
*
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
*
      LWMIN = N + MAX( NB*( NP0+1 ), 3 )
      LWORK = LWMIN
*
      LIWORK = 6*MAX( N, NPROCS+1, 4 )
*
      NN = MAX( N, NB, 2 )
      LRWORK = 5*NN + 4*N
*
*     IWORK, RWORK
      IPRWOR = IPWOR + LWORK
      IPIWOR = IPRWOR + LRWORK
      IPW = IPIWOR + LIWORK
*
      GOTO 3
*
*     PZLAPRNT  .
*
    3 WORKSIZ = MAX( NB, MXNP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
        WRITE( NPR, FMT = 9992 )NAME
        WRITE( NPR, FMT = 9998 )N, N, NPROCS
        WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
        WRITE( NPR, FMT = 9993 )NB, NB
*
        WRITE( NPR, FMT = * )'  IPA,  IPWOR,  IPRWOR,  IPW, MMIN' 
        WRITE( NPR, FMT = 9994 )IPA, IPWOR, IPRWOR, IPW, MMIN
    5   CONTINUE
*
 9994 FORMAT( / 5I7 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '    ',
     $      '       ', A7/ )
*
 9998 FORMAT( /'      A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'     '/)
 9993 FORMAT( / '       NB ',
     $       I2,' *',I2 // '     '/)
      STOP
      END
